Attribute VB_Name = "GLPicking2D"
' 2 D picking routines
Option Explicit
Public Sub ExamineClick2D(X, Y, _
x0, x1, y0, y1, z, _
result, PickSucces)

  Dim HitIdentif As Integer
  Dim i As Integer
  Dim hits As Long
  Dim selectbuf(0 To 30000) As GLuint ' array for the resultes of picking
  Dim BUFSIZE As Integer
  BUFSIZE = 30000
  PickSucces = False

  Selection2D X, Y, hits, selectbuf, BUFSIZE, _
  x0, x1, y0, y1, z, result
  
  If (hits > 0 And hits <= 4) Then PickSucces = True ' max 4 squares can be in contact

End Sub

Private Sub Selection2D(X, Y, _
hits As Long, selectbuf() As GLuint, BUFSIZE As Integer, _
x0, x1, y0, y1, z, result)

  Static XYidentif() As Single
  Dim viewport(0 To 3) As Long ' array for viewport
  Dim precision As Integer ' precision of square draving
  Dim HitIdentif As Integer ' identifikace zasahu
  precision = 100 ' precision of 2D pick placing
  ReDim XYidentif((precision + 1) * (precision + 1), 1 To 2)
  ' end of viewport duplication
  glDisable GL_STENCIL_TEST
  glDisable GL_DEPTH_TEST
  glGetIntegerv GL_VIEWPORT, viewport(0)
  glSelectBuffer BUFSIZE, selectbuf(0)
  glRenderMode GL_SELECT
  glInitNames
  glPushName 0 'intializing the name stack
  'setting the same geomety as for normal view
  glMatrixMode GL_PROJECTION
  glPushMatrix 'saving the original matrix
     glLoadIdentity 'this load identity is the probleme ??
    '1*1 region near cursor
    gluPickMatrix X, viewport(3) - Y, 1, 1, viewport(0)
    '30x30 region for debuging
  '  gluPickMatrix X, viewport(3) - Y, 30, 30, viewport(0)
    frmMain.Kamera "CentralEyePicking"
    
    glMatrixMode GL_MODELVIEW
        glPushMatrix ' saving the original matix again
        frmMain.recalcModelView
            
        DrawNumberedSqures x0, x1, y0, y1, z, precision, XYidentif
  
        'restoring the geometry
        glPopMatrix
    glMatrixMode GL_PROJECTION
  glPopMatrix 'restoring the original matrix
  glMatrixMode GL_MODELVIEW
  glFlush
  
  ' for debuging (to display the picking pattern on the screen)
  'SwapBuffers frmMain.hDC
    
  hits = glRenderMode(GL_RENDER)   'hits = objects in hit
   
  HitIdentif = selectbuf((1 - 1) * 4 + 3)
  
  'result(1) = x0 + Int((HitIdentif - 1) / precision) * ((x1 - x0) / precision) + ((x1 - x0) / precision) / 2
  result(1) = XYidentif(HitIdentif, 1)
  'result(2) = y0 + (((HitIdentif - 1) Mod precision)) * ((y1 - y0) / precision) + ((y1 - y0) / precision) / 2
  result(2) = XYidentif(HitIdentif, 2)
  result(3) = z

End Sub

Private Sub DrawNumberedSqures(x0, x1, y0, y1, z, precision, XYidentif() As Single)

Dim i As Integer
Dim j As Integer
Dim X As GLfloat
Dim Y As GLfloat
Dim stepx As GLfloat
Dim stepy As GLfloat
stepx = (x1 - x0) / precision
stepy = (y1 - y0) / precision

i = 0

For X = x0 To x1 Step stepx
    For Y = y0 To y1 Step stepy
    i = i + 1
        glLoadName (i)
          ' for debuging (cloring the objects for visualization)
          'glColor3f Rnd(1), Rnd(1), Rnd(1)
          glBegin GL_QUADS
          glVertex3f X, Y, z
          glVertex3f X + stepx, Y, z
          glVertex3f X + stepx, Y + stepx, z
          glVertex3f X, Y + stepx, z
          glEnd
            
    XYidentif(i, 1) = X + (stepx / 2) ' puting the centers of the squares
    XYidentif(i, 2) = Y + (stepy / 2) ' to an field for identification
      
    Next Y
Next X

End Sub

